=== debian/changelog ===
handbrake (6039svnppa1~precise1+6.0.1trisquel1) toutatis; urgency=low

  * Imported into Trisquel

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 02 Jul 2014 22:29:21 +0200

handbrake (6039svnppa1~precise1) precise; urgency=low
  * Snapshot
    - See timeline at http://trac.handbrake.fr/timeline

 -- John Stebbins <jstebbins.hb@gmail.com>  Sun, 11 Apr 2010 9:51:07 -0800
