=== debian/control ===
Source: handbrake
Section: graphics
Priority: optional
Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
Build-Depends: debhelper (>= 6), autotools-dev, libtool, libgudev-1.0-dev, intltool, autoconf, yasm (>= 1.1.0), libbz2-dev, zlib1g-dev, libgtk-3-dev, libwebkitgtk-3.0-dev, libnotify-dev, libgstreamer0.10-dev, libgstreamer-plugins-base0.10-dev, wget, python (>= 2.6), libappindicator-dev, libfribidi-dev (>= 0.19.0), libxml2-dev, libogg-dev, libtheora-dev, libvorbis-dev, libsamplerate0-dev, libfreetype6-dev, libfontconfig1-dev, libass-dev
Standards-Version: 3.8.4
Homepage: http://www.handbrake.fr/

Package: handbrake-cli
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: handbrake
Description: versatile DVD ripper and video transcoder - command line
 HandBrake is a versatile, easy-to-use tool for converting DVDs and other videos
 into H.264, MPEG-4, or OGG formatted media. It's particularly useful for making
 videos that are compatible with portable video devices such as the Apple
 iPod/iPhone. This package contains the command-line variant,
 HandBrakeCLI

Package: handbrake-gtk
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, libwebkitgtk-3.0-0, libnotify4
Conflicts: handbrake
Description: versatile DVD ripper and video transcoder - GTK GUI
 HandBrake is a versatile, easy-to-use tool for converting DVDs and other videos
 into H.264, MPEG-4, or OGG formatted media. It's particularly useful for making
 videos that are compatible with portable video devices such as the Apple
 iPod/iPhone. This package contains the graphical variant, ghb.
