=== source/encoder/CMakeLists.txt ===
# vim: syntax=cmake

add_library(encoder OBJECT ../x265.h
    ../Lib/TLibEncoder/TEncSampleAdaptiveOffset.h
    ../Lib/TLibEncoder/TEncSampleAdaptiveOffset.cpp
    ../Lib/TLibEncoder/TEncSearch.h
    ../Lib/TLibEncoder/TEncSearch.cpp
    analysis.cpp analysis.h
    predict.cpp  predict.h
    bitcost.cpp bitcost.h rdcost.h
    motion.cpp motion.h
    slicetype.cpp slicetype.h
    frameencoder.cpp frameencoder.h
    framefilter.cpp framefilter.h
    cturow.cpp cturow.h
    level.cpp level.h
    nal.cpp nal.h
    sei.cpp sei.h
    entropy.cpp entropy.h
    dpb.cpp dpb.h
    ratecontrol.cpp ratecontrol.h
    reference.cpp reference.h
    encoder.cpp encoder.h
    api.cpp
    weightPrediction.cpp)
