=== debian/changelog ===
handbrake (7412svnppa1~trusty1+7.0trisquel1) belenos; urgency=medium

  * Imported into Trisquel from ppa

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 25 Aug 2015 10:13:16 +0000

handbrake (7412svnppa1~trusty1) trusty; urgency=low
  * Snapshot
    - See timeline at http://trac.handbrake.fr/timeline

 -- John Stebbins <jstebbins.hb@gmail.com>  Sun, 11 Apr 2010 9:51:07 -0800
